/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     COMMENT = 258,
     VERSION = 259,
     HEADER_NAME = 260,
     CODE_NAME = 261,
     FUNCTION = 262,
     IDENTIFIER = 263,
     LBRA = 264,
     RBRA = 265,
     RCUR = 266,
     LCUR = 267,
     OPEN = 268,
     CODE = 269,
     SELECTED = 270,
     ANYTHING = 271,
     NON_CURLY = 272,
     INTEGER = 273,
     TYPE = 274,
     VISIBLE = 275,
     XYWH = 276,
     LABEL = 277,
     CALLBACKF = 278,
     LABELSIZE = 279,
     TEXTSIZE = 280,
     ALIGN = 281,
     FLOATR = 282,
     MAXIMUM = 283,
     MINIMUM = 284,
     STEP = 285,
     VALUE = 286,
     BOX = 287,
     DOWN_BOX = 288,
     WHEN = 289,
     RESIZABLE = 290,
     SIZE_RANGE = 291,
     TEXTFONT = 292,
     TOOLTIP = 293,
     CODE0 = 294,
     COLOR = 295,
     LABELCOLOR = 296,
     LABELTYPE = 297,
     SELECTION_COLOR = 298,
     TEXTCOLOR = 299,
     LABELFONT = 300,
     IMAGEATTR = 301,
     FL_WINDOW = 302,
     FL_BUTTON = 303,
     FL_INPUT = 304,
     FL_VALUE_INPUT = 305,
     FL_BROWSER = 306,
     FL_CHECK_BUTTON = 307,
     FL_TEXT_DISPLAY = 308,
     FL_OUTPUT = 309,
     FL_GROUP = 310,
     FL_MENU_BAR = 311,
     SUBMENU = 312,
     MENUITEM = 313,
     USERDATA = 314,
     SHORTCUT = 315,
     POSHEX = 316
   };
#endif
/* Tokens.  */
#define COMMENT 258
#define VERSION 259
#define HEADER_NAME 260
#define CODE_NAME 261
#define FUNCTION 262
#define IDENTIFIER 263
#define LBRA 264
#define RBRA 265
#define RCUR 266
#define LCUR 267
#define OPEN 268
#define CODE 269
#define SELECTED 270
#define ANYTHING 271
#define NON_CURLY 272
#define INTEGER 273
#define TYPE 274
#define VISIBLE 275
#define XYWH 276
#define LABEL 277
#define CALLBACKF 278
#define LABELSIZE 279
#define TEXTSIZE 280
#define ALIGN 281
#define FLOATR 282
#define MAXIMUM 283
#define MINIMUM 284
#define STEP 285
#define VALUE 286
#define BOX 287
#define DOWN_BOX 288
#define WHEN 289
#define RESIZABLE 290
#define SIZE_RANGE 291
#define TEXTFONT 292
#define TOOLTIP 293
#define CODE0 294
#define COLOR 295
#define LABELCOLOR 296
#define LABELTYPE 297
#define SELECTION_COLOR 298
#define TEXTCOLOR 299
#define LABELFONT 300
#define IMAGEATTR 301
#define FL_WINDOW 302
#define FL_BUTTON 303
#define FL_INPUT 304
#define FL_VALUE_INPUT 305
#define FL_BROWSER 306
#define FL_CHECK_BUTTON 307
#define FL_TEXT_DISPLAY 308
#define FL_OUTPUT 309
#define FL_GROUP 310
#define FL_MENU_BAR 311
#define SUBMENU 312
#define MENUITEM 313
#define USERDATA 314
#define SHORTCUT 315
#define POSHEX 316




/* Copy the first part of user declarations.  */
#line 1 "fluid.y"

#include <stdio.h>
#include <string.h>
char gWindowToCreate[1024]="";
char widgetLevel=0;
char gFluidConstant[1024]="";
char gCurrentMenubar[1024]="";
char gMenuDirectory[1024]="";
char gMenuLevel=0;
char gMenuItemName[1024]="nil";
char gMenuItemCallback[1024]="nil";
char gMenuItemUserdata[1024]="nil";
char gMenuItemType=0;
unsigned int gMenuItemShortcut=0;

void ResetMenuItemSettings()
{
	sprintf(gMenuItemName, "Item");
	sprintf(gMenuItemCallback, "nil");
	sprintf(gMenuItemUserdata, "nil");
	gMenuItemType=0;
	gMenuItemShortcut=0;
}

int FluidConstantToNumber(char *str)
{
	if (!strcmp(str, "Normal")){return 0;}
	if (!strcmp(str, "Vertical")){return 0;}
	if (!strcmp(str, "Dot")){return 0;}
	if (!strcmp(str, "Integer")){return 0;}
	if (!strcmp(str, "normal")){return 0;}
	if (!strcmp(str, "No_Select")){return 0;}
	if (!strcmp(str, "BOTH")){return 0;}
	if (!strcmp(str, "Toggle")){return 1;}
	if (!strcmp(str, "Horizontal")){return 1;}
	if (!strcmp(str, "Simple")){return 1;}
	if (!strcmp(str, "Line")){return 1;}
	if (!strcmp(str, "Float")){return 1;}
	if (!strcmp(str, "popup1")){return 1;}
	if (!strcmp(str, "Select")){return 1;}
	if (!strcmp(str, "HORIZONTAL")){return 1;}
	if (!strcmp(str, "Vert_Fill")){return 2;}
	if (!strcmp(str, "Fill")){return 2;}
	if (!strcmp(str, "Int")){return 2;}
	if (!strcmp(str, "popup2")){return 2;}
	if (!strcmp(str, "Hold")){return 2;}
	if (!strcmp(str, "VERTICAL")){return 2;}
	if (!strcmp(str, "Horz_Fill")){return 3;}
	if (!strcmp(str, "popup3")){return 3;}
	if (!strcmp(str, "Multi")){return 3;}
	if (!strcmp(str, "Vert_Knob")){return 4;}
	if (!strcmp(str, "Multiline")){return 4;}
	if (!strcmp(str, "popup12")){return 4;}
	if (!strcmp(str, "Horz_Knob")){return 5;}
	if (!strcmp(str, "Secret")){return 5;}
	if (!strcmp(str, "popup23")){return 5;}
	if (!strcmp(str, "HORIZONTAL_ALWAYS")){return 5;}
	if (!strcmp(str, "popup13")){return 6;}
	if (!strcmp(str, "VERTICAL_ALWAYS")){return 6;}
	if (!strcmp(str, "popup123")){return 7;}
	if (!strcmp(str, "BOTH_ALWAYS")){return 7;}
	if (!strcmp(str, "Radio")){return 102;}
	
	return -1;
}

int FluidMenuConstantToNumber(char *str)
{
	if (!strcmp(str, "Toggle")){return 2;}
	if (!strcmp(str, "Radio")){return 8;}
	
	return 0;
}

char *LevelUp(char *str)
{
	int i;
	for (i=strlen(str)-1; i>=0; i--)
	{
		if (str[i]=='/'){str[i]='\0';break;}
		str[i]='\0';
	}
}


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 313 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  4
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   264

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  62
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  88
/* YYNRULES -- Number of rules.  */
#define YYNRULES  177
/* YYNRULES -- Number of states.  */
#define YYNSTATES  294

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   316

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     9,    10,    11,    12,    28,    29,    33,
      35,    43,    44,    45,    46,    56,    57,    58,    59,    69,
      70,    71,    72,    82,    84,    86,    89,    93,    94,    97,
     101,   102,   105,   108,   110,   112,   113,   121,   122,   129,
     131,   133,   135,   137,   139,   141,   143,   145,   147,   148,
     152,   153,   154,   160,   161,   162,   168,   169,   170,   176,
     177,   182,   183,   188,   197,   198,   199,   203,   204,   205,
     211,   220,   224,   225,   227,   229,   231,   233,   235,   237,
     239,   241,   243,   245,   247,   249,   251,   253,   255,   257,
     259,   261,   263,   265,   267,   269,   271,   273,   275,   277,
     280,   281,   283,   285,   287,   289,   291,   293,   295,   297,
     299,   301,   303,   305,   307,   309,   311,   313,   315,   317,
     319,   321,   323,   325,   327,   329,   331,   333,   335,   337,
     339,   341,   343,   346,   349,   350,   351,   359,   362,   363,
     367,   368,   372,   373,   377,   378,   379,   380,   381,   393,
     396,   399,   402,   405,   408,   411,   414,   416,   419,   421,
     422,   423,   424,   425,   437,   440,   443,   446,   447,   451,
     454,   457,   460,   463,   465,   468,   471,   474
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      63,     0,    -1,     3,     4,     5,     6,    64,    -1,    -1,
      -1,    -1,     7,    12,    65,     8,    66,     9,    10,    67,
      11,    12,   104,    11,    12,    68,    11,    -1,    -1,    70,
      69,    68,    -1,    70,    -1,    14,    12,   146,    11,    12,
     104,    11,    -1,    -1,    -1,    -1,    71,    88,    72,   106,
      73,    12,   104,    11,    81,    -1,    -1,    -1,    -1,    74,
      56,    75,   106,    76,    12,   104,    11,    82,    -1,    -1,
      -1,    -1,    77,    55,    78,   106,    79,    12,   104,    11,
      81,    -1,    27,    -1,    18,    -1,    12,    11,    -1,    12,
      68,    11,    -1,    -1,    12,    11,    -1,    12,    83,    11,
      -1,    -1,    86,    83,    -1,    84,    83,    -1,    84,    -1,
      86,    -1,    -1,    85,    57,   106,    12,    99,    11,    82,
      -1,    -1,    58,   106,    12,    87,    89,    11,    -1,    47,
      -1,    48,    -1,    49,    -1,    50,    -1,    51,    -1,    52,
      -1,    53,    -1,    54,    -1,     8,    -1,    -1,    90,   103,
      89,    -1,    -1,    -1,    22,    91,   107,    92,    89,    -1,
      -1,    -1,    23,    93,   107,    94,    89,    -1,    -1,    -1,
      59,    95,   107,    96,    89,    -1,    -1,    60,    61,    97,
      89,    -1,    -1,    19,     8,    98,    89,    -1,    21,    12,
      18,    18,    18,    18,    11,    89,    -1,    -1,    -1,   100,
     103,    99,    -1,    -1,    -1,    22,   101,   107,   102,    99,
      -1,    21,    12,    18,    18,    18,    18,    11,    99,    -1,
      19,     8,    99,    -1,    -1,    13,    -1,    15,    -1,   129,
      -1,   123,    -1,   122,    -1,   124,    -1,   125,    -1,   148,
      -1,   147,    -1,   127,    -1,   126,    -1,   128,    -1,   130,
      -1,   131,    -1,   132,    -1,   137,    -1,   113,    -1,   139,
      -1,   142,    -1,   143,    -1,   149,    -1,   145,    -1,   144,
      -1,   138,    -1,   140,    -1,     8,    -1,   105,   104,    -1,
      -1,    13,    -1,    15,    -1,   117,    -1,   108,    -1,   129,
      -1,   111,    -1,   115,    -1,   123,    -1,   122,    -1,   124,
      -1,   125,    -1,   148,    -1,   147,    -1,   127,    -1,   126,
      -1,   128,    -1,   130,    -1,   131,    -1,   132,    -1,   137,
      -1,   113,    -1,   139,    -1,   142,    -1,   143,    -1,   149,
      -1,   145,    -1,   144,    -1,   138,    -1,   140,    -1,     8,
      -1,     8,    -1,    12,    11,    -1,   146,    11,    -1,    -1,
      -1,    19,    12,     8,   109,     8,   110,    11,    -1,    19,
       8,    -1,    -1,    22,   112,   107,    -1,    -1,    38,   114,
     107,    -1,    -1,    23,   116,   107,    -1,    -1,    -1,    -1,
      -1,    21,    12,    18,   118,    18,   119,    18,   120,    18,
     121,    11,    -1,    29,    80,    -1,    28,    80,    -1,    30,
      80,    -1,    31,    80,    -1,    25,    18,    -1,    24,    18,
      -1,    26,    18,    -1,    20,    -1,    34,    18,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    36,    12,    18,   133,    18,
     134,    18,   135,    18,   136,    11,    -1,    37,    18,    -1,
      45,    18,    -1,    39,   107,    -1,    -1,    46,   141,   107,
      -1,    40,    18,    -1,    41,    18,    -1,    43,    18,    -1,
      44,    18,    -1,    17,    -1,    17,   146,    -1,    33,     8,
      -1,    32,     8,    -1,    42,     8,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint8 yyrline[] =
{
       0,    87,    87,    89,    89,    89,    89,    92,    92,    92,
      94,    95,    95,    95,    95,    97,    97,    97,    97,    99,
      99,    99,    99,   102,   102,   104,   104,   104,   106,   106,
     106,   108,   108,   108,   108,   110,   110,   112,   112,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   116,   116,
     116,   116,   116,   117,   117,   117,   118,   118,   118,   119,
     119,   120,   120,   121,   121,   124,   124,   124,   124,   124,
     125,   126,   126,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   132,
     132,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   134,   134,   134,   134,   134,   134,   134,
     134,   136,   136,   138,   141,   141,   141,   141,   143,   143,
     145,   145,   147,   147,   149,   149,   149,   149,   149,   151,
     153,   155,   157,   159,   161,   163,   165,   167,   169,   171,
     171,   171,   171,   171,   173,   175,   177,   179,   179,   181,
     183,   185,   187,   190,   190,   192,   194,   196
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "COMMENT", "VERSION", "HEADER_NAME",
  "CODE_NAME", "FUNCTION", "IDENTIFIER", "LBRA", "RBRA", "RCUR", "LCUR",
  "OPEN", "CODE", "SELECTED", "ANYTHING", "NON_CURLY", "INTEGER", "TYPE",
  "VISIBLE", "XYWH", "LABEL", "CALLBACKF", "LABELSIZE", "TEXTSIZE",
  "ALIGN", "FLOATR", "MAXIMUM", "MINIMUM", "STEP", "VALUE", "BOX",
  "DOWN_BOX", "WHEN", "RESIZABLE", "SIZE_RANGE", "TEXTFONT", "TOOLTIP",
  "CODE0", "COLOR", "LABELCOLOR", "LABELTYPE", "SELECTION_COLOR",
  "TEXTCOLOR", "LABELFONT", "IMAGEATTR", "FL_WINDOW", "FL_BUTTON",
  "FL_INPUT", "FL_VALUE_INPUT", "FL_BROWSER", "FL_CHECK_BUTTON",
  "FL_TEXT_DISPLAY", "FL_OUTPUT", "FL_GROUP", "FL_MENU_BAR", "SUBMENU",
  "MENUITEM", "USERDATA", "SHORTCUT", "POSHEX", "$accept", "start",
  "function", "@1", "@2", "@3", "blocklist", "@4", "block", "@5", "@6",
  "@7", "@8", "@9", "@10", "@11", "@12", "@13", "number", "subwidgetlist",
  "submenulist", "submenusOrItems", "submenu", "@14", "menuitem", "@15",
  "widget", "attriblist2", "@16", "@17", "@18", "@19", "@20", "@21", "@22",
  "@23", "@24", "attriblist3", "@25", "@26", "@27", "attrib2",
  "attriblist", "attrib", "name_or_empty", "name_or_empty_three", "type",
  "@28", "@29", "label", "@30", "tooltip", "@31", "callbackf", "@32",
  "xywh", "@33", "@34", "@35", "@36", "minimum", "maximum", "step",
  "value", "textsize", "labelsize", "align", "visible", "when",
  "resizable", "size_range", "@37", "@38", "@39", "@40", "textfont",
  "labelfont", "code0", "imageattr", "@41", "color", "labelcolor",
  "selection_color", "textcolor", "non_curly", "down_box", "box",
  "labeltype", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    62,    63,    65,    66,    67,    64,    69,    68,    68,
      70,    71,    72,    73,    70,    74,    75,    76,    70,    77,
      78,    79,    70,    80,    80,    81,    81,    81,    82,    82,
      82,    83,    83,    83,    83,    85,    84,    87,    86,    88,
      88,    88,    88,    88,    88,    88,    88,    88,    90,    89,
      91,    92,    89,    93,    94,    89,    95,    96,    89,    97,
      89,    98,    89,    89,    89,   100,    99,   101,   102,    99,
      99,    99,    99,   103,   103,   103,   103,   103,   103,   103,
     103,   103,   103,   103,   103,   103,   103,   103,   103,   103,
     103,   103,   103,   103,   103,   103,   103,   103,   103,   104,
     104,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   105,   105,   105,   105,   105,   105,   105,   105,   105,
     105,   106,   106,   107,   109,   110,   108,   108,   112,   111,
     114,   113,   116,   115,   118,   119,   120,   121,   117,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   133,
     134,   135,   136,   132,   137,   138,   139,   141,   140,   142,
     143,   144,   145,   146,   146,   147,   148,   149
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     5,     0,     0,     0,    15,     0,     3,     1,
       7,     0,     0,     0,     9,     0,     0,     0,     9,     0,
       0,     0,     9,     1,     1,     2,     3,     0,     2,     3,
       0,     2,     2,     1,     1,     0,     7,     0,     6,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     3,
       0,     0,     5,     0,     0,     5,     0,     0,     5,     0,
       4,     0,     4,     8,     0,     0,     3,     0,     0,     5,
       8,     3,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       0,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     0,     0,     7,     2,     0,     3,
       0,     3,     0,     3,     0,     0,     0,     0,    11,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     1,     0,
       0,     0,     0,    11,     2,     2,     2,     0,     3,     2,
       2,     2,     2,     1,     2,     2,     2,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,     1,     0,     0,     0,     2,     3,
       0,     4,     0,     0,     5,     0,     0,   100,   130,   101,
     102,     0,   156,     0,   138,   142,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   158,     0,     0,   140,
       0,     0,     0,     0,     0,     0,     0,   167,     0,   100,
     104,   106,   121,   107,   103,   109,   108,   110,   111,   115,
     114,   116,   105,   117,   118,   119,   120,   128,   122,   129,
     123,   124,   127,   126,   113,   112,   125,   137,     0,     0,
       0,     0,   154,   153,   155,    24,    23,   150,   149,   151,
     152,   176,   175,   157,     0,   164,     0,   173,   166,     0,
     169,   170,   177,   171,   172,   165,     0,     0,    99,   134,
     144,   139,   143,   159,   141,   174,   133,   168,    11,     0,
       0,     0,     0,     0,     7,     0,     0,     0,   135,   145,
     160,     0,     6,    11,    47,    39,    40,    41,    42,    43,
      44,    45,    46,    12,    16,    20,     0,     0,     0,     0,
       8,     0,     0,     0,   136,   146,   161,     0,   131,     0,
      13,    17,    21,     0,     0,   100,   132,     0,     0,     0,
     147,   162,     0,   100,   100,   100,     0,     0,    10,     0,
       0,     0,   148,   163,    27,    30,    27,    11,    14,    35,
      18,    22,    25,     0,    28,     0,     0,    33,     0,    34,
      26,     0,    29,    32,     0,    31,    37,     0,    48,    65,
       0,     0,    50,    53,    56,     0,     0,     0,     0,     0,
      67,     0,     0,    61,     0,     0,     0,     0,    59,    38,
      98,    73,    74,    48,    89,    77,    76,    78,    79,    83,
      82,    84,    75,    85,    86,    87,    88,    96,    90,    97,
      91,    92,    95,    94,    81,    80,    93,    65,     0,     0,
      30,    65,    48,     0,    51,    54,    57,    48,    49,    71,
       0,    68,    36,    66,    62,     0,    48,    48,    48,    60,
       0,    65,     0,    52,    55,    58,     0,    69,     0,     0,
      48,    65,    63,    70
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     8,    10,    12,    15,   123,   133,   124,   125,
     151,   167,   126,   152,   168,   127,   153,   169,    87,   188,
     190,   196,   197,   198,   199,   208,   143,   216,   217,   225,
     276,   226,   277,   227,   278,   267,   262,   221,   222,   259,
     281,   233,    48,    49,   160,    98,    50,   119,   146,    51,
      80,    52,    96,    53,    81,    54,   120,   147,   163,   176,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,   121,   148,   164,   177,    66,    67,    68,    69,   106,
      70,    71,    72,    73,    99,    74,    75,    76
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -252
static const yytype_int16 yypact[] =
{
      40,    47,    57,    58,  -252,    59,    69,    52,  -252,  -252,
      76,  -252,    84,   103,  -252,   112,   119,    66,  -252,  -252,
    -252,   182,  -252,   122,  -252,  -252,   125,   133,   156,     4,
       4,     4,     4,   134,   177,   174,  -252,   181,   178,  -252,
     180,   184,   185,   190,   186,   187,   188,  -252,   189,    66,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,   191,   192,
     180,   180,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,
    -252,  -252,  -252,  -252,   193,  -252,   180,   180,  -252,   196,
    -252,  -252,  -252,  -252,  -252,  -252,   180,   197,  -252,  -252,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,     0,   200,
     194,   195,   202,   204,   205,    19,   145,   162,  -252,  -252,
    -252,   180,  -252,     0,  -252,  -252,  -252,  -252,  -252,  -252,
    -252,  -252,  -252,  -252,  -252,  -252,   207,   201,   203,   209,
    -252,   183,   183,   183,  -252,  -252,  -252,   210,  -252,   212,
    -252,  -252,  -252,   206,   208,    66,  -252,   213,   215,   216,
    -252,  -252,   218,    66,    66,    66,   219,   220,  -252,   221,
     222,   223,  -252,  -252,   224,   225,   224,    -2,  -252,    -6,
    -252,  -252,  -252,   227,  -252,   183,   228,   -16,   198,   -16,
    -252,   229,  -252,  -252,   183,  -252,  -252,   230,     2,    17,
     232,   231,  -252,  -252,  -252,   199,   233,   124,   237,   234,
    -252,   236,   124,  -252,   217,   180,   180,   180,  -252,  -252,
    -252,  -252,  -252,     2,  -252,  -252,  -252,  -252,  -252,  -252,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,    17,   235,   180,
     225,    17,     2,   238,  -252,  -252,  -252,     2,  -252,  -252,
     239,  -252,  -252,  -252,  -252,   240,     2,     2,     2,  -252,
     241,    17,   243,  -252,  -252,  -252,   244,  -252,   252,   253,
       2,    17,  -252,  -252
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -252,  -252,  -252,  -252,  -252,  -252,  -129,  -252,  -252,  -252,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,   -13,    62,
     -11,  -164,  -252,  -252,  -252,  -252,  -252,  -230,  -252,  -252,
    -252,  -252,  -252,  -252,  -252,  -252,  -252,  -251,  -252,  -252,
    -252,    28,   -47,  -252,  -145,   -80,  -252,  -252,  -252,  -252,
    -252,  -202,  -252,  -252,  -252,  -252,  -252,  -252,  -252,  -252,
    -188,  -173,  -142,  -140,  -139,  -103,  -102,  -101,  -100,   -93,
     -92,  -252,  -252,  -252,  -252,   -84,   -82,   -81,   -46,  -252,
     -45,   -44,   -42,   -36,   -86,   -35,   -34,   -33
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -73
static const yytype_int16 yytable[] =
{
     111,   112,   108,   268,   150,   194,   269,   161,   162,   192,
     273,   115,   122,   -64,   122,   234,   114,    88,    89,    90,
     234,   210,    85,   211,   212,   213,   117,   134,   -72,   235,
     287,    86,   274,   203,   235,   205,   218,   279,   219,   220,
     293,   -35,   195,     1,   236,   149,   283,   284,   285,   236,
     201,     3,   195,   -19,   -15,   -19,   -15,     4,   193,   207,
     292,   214,   215,     5,     9,     6,   135,   136,   137,   138,
     139,   140,   141,   142,    18,   237,     7,   238,   239,    19,
     237,    20,   238,   239,    11,    21,    22,    23,    24,    25,
      26,    27,    28,    13,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    14,   240,   241,   242,   243,   172,   240,
     241,   242,   243,    16,   244,   245,   179,   180,   181,   244,
     245,    17,   230,   246,    79,   247,   248,   231,   246,   232,
     247,   248,    91,    82,    22,   264,   265,   266,    26,    27,
      28,    83,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,   249,   250,   251,    84,   252,   249,   250,   251,   271,
     252,   253,   254,   255,   256,    92,   253,   254,   255,   256,
      77,   158,    93,    94,    78,   159,    95,    97,   102,   109,
     107,   144,   100,   101,   103,   104,   105,   116,   128,   118,
     110,   113,   129,   130,   131,   132,    -9,   145,   154,   155,
     157,   156,   165,   166,   170,   173,   171,   174,   175,   178,
     182,   183,   184,   185,   186,   263,   187,   189,   200,   202,
     223,   206,   209,   224,   229,   257,   258,   260,   191,   272,
     261,     0,     0,   270,     0,   204,   275,   280,   282,   286,
     228,   288,   289,   290,   291
};

static const yytype_int16 yycheck[] =
{
      80,    81,    49,   233,   133,    11,   257,   152,   153,    11,
     261,    97,    14,    11,    14,   217,    96,    30,    31,    32,
     222,    19,    18,    21,    22,    23,   106,     8,    11,   217,
     281,    27,   262,   197,   222,   199,    19,   267,    21,    22,
     291,    57,    58,     3,   217,   131,   276,   277,   278,   222,
     195,     4,    58,    55,    56,    55,    56,     0,   187,   204,
     290,    59,    60,     5,    12,     6,    47,    48,    49,    50,
      51,    52,    53,    54,     8,   217,     7,   217,   217,    13,
     222,    15,   222,   222,     8,    19,    20,    21,    22,    23,
      24,    25,    26,     9,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    10,   217,   217,   217,   217,   165,   222,
     222,   222,   222,    11,   217,   217,   173,   174,   175,   222,
     222,    12,     8,   217,    12,   217,   217,    13,   222,    15,
     222,   222,     8,    18,    20,   225,   226,   227,    24,    25,
      26,    18,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,   217,   217,   217,    18,   217,   222,   222,   222,   259,
     222,   217,   217,   217,   217,     8,   222,   222,   222,   222,
       8,     8,    18,    12,    12,    12,    18,    17,     8,     8,
      11,    56,    18,    18,    18,    18,    18,    11,     8,    12,
      18,    18,    18,    18,    12,    11,    11,    55,    11,    18,
      11,    18,    12,    11,    18,    12,    18,    12,    12,    11,
      11,    11,    11,    11,    11,    18,    12,    12,    11,    11,
       8,    12,    12,    12,    11,     8,    12,    11,   186,   260,
     222,    -1,    -1,    18,    -1,    57,    18,    18,    18,    18,
      61,    18,    18,    11,    11
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    63,     4,     0,     5,     6,     7,    64,    12,
      65,     8,    66,     9,    10,    67,    11,    12,     8,    13,
      15,    19,    20,    21,    22,    23,    24,    25,    26,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,   104,   105,
     108,   111,   113,   115,   117,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   137,   138,   139,   140,
     142,   143,   144,   145,   147,   148,   149,     8,    12,    12,
     112,   116,    18,    18,    18,    18,    27,    80,    80,    80,
      80,     8,     8,    18,    12,    18,   114,    17,   107,   146,
      18,    18,     8,    18,    18,    18,   141,    11,   104,     8,
      18,   107,   107,    18,   107,   146,    11,   107,    12,   109,
     118,   133,    14,    68,    70,    71,    74,    77,     8,    18,
      18,    12,    11,    69,     8,    47,    48,    49,    50,    51,
      52,    53,    54,    88,    56,    55,   110,   119,   134,   146,
      68,    72,    75,    78,    11,    18,    18,    11,     8,    12,
     106,   106,   106,   120,   135,    12,    11,    73,    76,    79,
      18,    18,   104,    12,    12,    12,   121,   136,    11,   104,
     104,   104,    11,    11,    11,    11,    11,    12,    81,    12,
      82,    81,    11,    68,    11,    58,    83,    84,    85,    86,
      11,   106,    11,    83,    57,    83,    12,   106,    87,    12,
      19,    21,    22,    23,    59,    60,    89,    90,    19,    21,
      22,    99,   100,     8,    12,    91,    93,    95,    61,    11,
       8,    13,    15,   103,   113,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   137,   138,   139,   140,
     142,   143,   144,   145,   147,   148,   149,     8,    12,   101,
      11,   103,    98,    18,   107,   107,   107,    97,    89,    99,
      18,   107,    82,    99,    89,    18,    92,    94,    96,    89,
      18,   102,    18,    89,    89,    89,    18,    99,    18,    18,
      11,    11,    89,    99
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 89 "fluid.y"
    {fprintf(gParserOutput, "--function ");}
    break;

  case 4:
#line 89 "fluid.y"
    {fprintf(gParserOutput, yytext);}
    break;

  case 5:
#line 89 "fluid.y"
    {fprintf(gParserOutput, "()\n");}
    break;

  case 6:
#line 89 "fluid.y"
    {fprintf(gParserOutput, "\n--end\n");}
    break;

  case 7:
#line 92 "fluid.y"
    {fprintf(gParserOutput, "\n");}
    break;

  case 11:
#line 95 "fluid.y"
    {ignoreType=0;widgetType[0]='\0';}
    break;

  case 12:
#line 95 "fluid.y"
    {if (widgetType[0]=='\0'){sprintf(widgetType, yytext);}}
    break;

  case 13:
#line 95 "fluid.y"
    {fprintf(gParserOutput, "do %s= fltk:%s(0,0,0,0,\"\")\n", widgetIdentifier, widgetType);if (!strcmp(widgetType, "Fl_Double_Window")){sprintf(gWindowToCreate, widgetIdentifier);}widgetLevel++;}
    break;

  case 14:
#line 95 "fluid.y"
    {widgetLevel--;fprintf(gParserOutput, "end\n");if ( (gWindowToCreate[0]!='\0') && (widgetLevel==0) ){fprintf(gParserOutput, "%s:show()\n", gWindowToCreate);gWindowToCreate[0]='\0';}}
    break;

  case 15:
#line 97 "fluid.y"
    {ignoreType=0;widgetType[0]='\0';}
    break;

  case 16:
#line 97 "fluid.y"
    {if (widgetType[0]=='\0'){sprintf(widgetType, yytext);}}
    break;

  case 17:
#line 97 "fluid.y"
    {fprintf(gParserOutput, "do %s= fltk:%s(0,0,0,0,\"\")\nmenudir0=\"\"\n", widgetIdentifier, widgetType);sprintf(gCurrentMenubar, widgetIdentifier);}
    break;

  case 18:
#line 97 "fluid.y"
    {fprintf(gParserOutput, "Fl_Group:current(Fl_Group:current():parent())\nend\n");}
    break;

  case 19:
#line 99 "fluid.y"
    {ignoreType=0;widgetType[0]='\0';}
    break;

  case 20:
#line 99 "fluid.y"
    {if (widgetType[0]=='\0'){sprintf(widgetType, yytext);}}
    break;

  case 21:
#line 99 "fluid.y"
    {fprintf(gParserOutput, "do %s= fltk:%s(0,0,0,0,\"\")\n", widgetIdentifier, widgetType);}
    break;

  case 22:
#line 99 "fluid.y"
    {fprintf(gParserOutput, "Fl_Group:current(Fl_Group:current():parent())\nend\n");}
    break;

  case 35:
#line 110 "fluid.y"
    {gMenuLevel++;}
    break;

  case 36:
#line 110 "fluid.y"
    {gMenuLevel--;}
    break;

  case 37:
#line 112 "fluid.y"
    {ResetMenuItemSettings();}
    break;

  case 38:
#line 112 "fluid.y"
    {fprintf(gParserOutput, "%s:add(%s,%d,%s,%s,%d)\n", gCurrentMenubar, gMenuItemName, gMenuItemShortcut, gMenuItemCallback, gMenuItemUserdata, gMenuItemType);}
    break;

  case 39:
#line 114 "fluid.y"
    {ignoreType=1;sprintf(widgetType, "Fl_Double_Window");}
    break;

  case 48:
#line 116 "fluid.y"
    {/*fprintf(gParserOutput, "--");*/}
    break;

  case 50:
#line 116 "fluid.y"
    {sprintf(gMenuItemName, "itemname");fprintf(gParserOutput, "itemname=menudir%d..\"", gMenuLevel);}
    break;

  case 51:
#line 116 "fluid.y"
    {fprintf(gParserOutput, "\"\n");}
    break;

  case 53:
#line 117 "fluid.y"
    {sprintf(gMenuItemCallback, "itemcallback");fprintf(gParserOutput, "itemcallback=");}
    break;

  case 54:
#line 117 "fluid.y"
    {fprintf(gParserOutput, "\n");}
    break;

  case 56:
#line 118 "fluid.y"
    {sprintf(gMenuItemUserdata, "itemuserdata");fprintf(gParserOutput, "itemuserdata=\"");}
    break;

  case 57:
#line 118 "fluid.y"
    {fprintf(gParserOutput, "\"\n");}
    break;

  case 59:
#line 119 "fluid.y"
    {gMenuItemShortcut=atoi(yytext);}
    break;

  case 61:
#line 120 "fluid.y"
    {gMenuItemType= FluidMenuConstantToNumber(yytext);}
    break;

  case 65:
#line 124 "fluid.y"
    {/*fprintf(gParserOutput, "--");*/}
    break;

  case 67:
#line 124 "fluid.y"
    {fprintf(gParserOutput, "menudir%d=menudir%d..\"", gMenuLevel, gMenuLevel-1);}
    break;

  case 68:
#line 124 "fluid.y"
    {fprintf(gParserOutput, "/\"\n");}
    break;

  case 98:
#line 130 "fluid.y"
    {fprintf(gParserOutput, "--unknown attribute: %s\n", yytext);}
    break;

  case 130:
#line 134 "fluid.y"
    {fprintf(gParserOutput, "--unknown attribute: %s\n", yytext);}
    break;

  case 131:
#line 136 "fluid.y"
    {sprintf(widgetIdentifier, yytext);}
    break;

  case 132:
#line 136 "fluid.y"
    {sprintf(widgetIdentifier, "widget");}
    break;

  case 134:
#line 141 "fluid.y"
    {if (!ignoreType){sprintf(gFluidConstant, "%s_", yytext); fprintf(gParserOutput, "%s:type(", widgetIdentifier);}}
    break;

  case 135:
#line 141 "fluid.y"
    {if (!ignoreType){strcat(gFluidConstant, yytext);fprintf(gParserOutput, "%d)\n", FluidConstantToNumber(gFluidConstant));}}
    break;

  case 137:
#line 141 "fluid.y"
    {if (!ignoreType){fprintf(gParserOutput, "%s:type(%d)\n", widgetIdentifier, FluidConstantToNumber(yytext));}}
    break;

  case 138:
#line 143 "fluid.y"
    {fprintf(gParserOutput, "%s:label(\"", widgetIdentifier);}
    break;

  case 139:
#line 143 "fluid.y"
    {fprintf(gParserOutput, "\")\n");}
    break;

  case 140:
#line 145 "fluid.y"
    {fprintf(gParserOutput, "%s:tooltip(\"", widgetIdentifier);}
    break;

  case 141:
#line 145 "fluid.y"
    {fprintf(gParserOutput, "\")\n");}
    break;

  case 142:
#line 147 "fluid.y"
    {fprintf(gParserOutput, "%s:callback(", widgetIdentifier);}
    break;

  case 143:
#line 147 "fluid.y"
    {fprintf(gParserOutput, ")\n");}
    break;

  case 144:
#line 149 "fluid.y"
    {rectx=atoi(yytext);}
    break;

  case 145:
#line 149 "fluid.y"
    {recty=atoi(yytext);}
    break;

  case 146:
#line 149 "fluid.y"
    {recth=atoi(yytext);}
    break;

  case 147:
#line 149 "fluid.y"
    {rectw=atoi(yytext);}
    break;

  case 148:
#line 149 "fluid.y"
    {fprintf(gParserOutput, "%s:resize(%d,%d,%d,%d)\n", widgetIdentifier, rectx,recty,recth,rectw);}
    break;

  case 149:
#line 151 "fluid.y"
    {fprintf(gParserOutput, "%s:minimum(%s)\n", widgetIdentifier, yytext);}
    break;

  case 150:
#line 153 "fluid.y"
    {fprintf(gParserOutput, "%s:maximum(%s)\n", widgetIdentifier, yytext);}
    break;

  case 151:
#line 155 "fluid.y"
    {fprintf(gParserOutput, "%s:step(%s)\n", widgetIdentifier, yytext);}
    break;

  case 152:
#line 157 "fluid.y"
    {fprintf(gParserOutput, "%s:value(%s)\n", widgetIdentifier, yytext);}
    break;

  case 153:
#line 159 "fluid.y"
    {fprintf(gParserOutput, "%s:textsize(%s)\n", widgetIdentifier, yytext);}
    break;

  case 154:
#line 161 "fluid.y"
    {fprintf(gParserOutput, "%s:labelsize(%s)\n", widgetIdentifier, yytext);}
    break;

  case 155:
#line 163 "fluid.y"
    {fprintf(gParserOutput, "%s:align(%s)\n", widgetIdentifier, yytext);}
    break;

  case 156:
#line 165 "fluid.y"
    {fprintf(gParserOutput, "--%s:show()\n", widgetIdentifier);}
    break;

  case 157:
#line 167 "fluid.y"
    {fprintf(gParserOutput, "%s:when(%s)\n", widgetIdentifier, yytext);}
    break;

  case 158:
#line 169 "fluid.y"
    {fprintf(gParserOutput, "Fl_Group:current():resizable(%s)\n", widgetIdentifier);}
    break;

  case 159:
#line 171 "fluid.y"
    {rectx=atoi(yytext);}
    break;

  case 160:
#line 171 "fluid.y"
    {recty=atoi(yytext);}
    break;

  case 161:
#line 171 "fluid.y"
    {recth=atoi(yytext);}
    break;

  case 162:
#line 171 "fluid.y"
    {rectw=atoi(yytext);}
    break;

  case 163:
#line 171 "fluid.y"
    {fprintf(gParserOutput, "%s:size_range(%d,%d,%d,%d)\n", widgetIdentifier, rectx,recty,recth,rectw);}
    break;

  case 164:
#line 173 "fluid.y"
    {fprintf(gParserOutput, "%s:textfont(%s)\n", widgetIdentifier, yytext);}
    break;

  case 165:
#line 175 "fluid.y"
    {fprintf(gParserOutput, "%s:labelfont(%s)\n", widgetIdentifier, yytext);}
    break;

  case 166:
#line 177 "fluid.y"
    {fprintf(gParserOutput, "\n");}
    break;

  case 167:
#line 179 "fluid.y"
    {fprintf(gParserOutput, "fltk.fl_register_images()\nlocal img = Fl_Shared_Image.get(\"");}
    break;

  case 168:
#line 179 "fluid.y"
    {fprintf(gParserOutput, "\")\n%s:image(img)\n%s:redraw()\n", widgetIdentifier, widgetIdentifier);}
    break;

  case 169:
#line 181 "fluid.y"
    {fprintf(gParserOutput, "%s:color(%s)\n", widgetIdentifier, yytext);}
    break;

  case 170:
#line 183 "fluid.y"
    {fprintf(gParserOutput, "%s:labelcolor(%s)\n", widgetIdentifier, yytext);}
    break;

  case 171:
#line 185 "fluid.y"
    {fprintf(gParserOutput, "%s:selection_color(%s)\n", widgetIdentifier, yytext);}
    break;

  case 172:
#line 187 "fluid.y"
    {fprintf(gParserOutput, "%s:textcolor(%s)\n", widgetIdentifier, yytext);}
    break;

  case 175:
#line 192 "fluid.y"
    {fprintf(gParserOutput, "%s:down_box(fltk.FL_%s)\n", widgetIdentifier, yytext);}
    break;

  case 176:
#line 194 "fluid.y"
    {fprintf(gParserOutput, "%s:box(fltk.FL_%s)\n", widgetIdentifier, yytext);}
    break;

  case 177:
#line 196 "fluid.y"
    {fprintf(gParserOutput, "%s:labeltype(fltk.FL_%s)\n", widgetIdentifier, yytext);}
    break;


/* Line 1267 of yacc.c.  */
#line 2191 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 197 "fluid.y"



